package database

import (
	"chromagies/src/config"
	"database/sql"
	"fmt"
	"log"

	_ "github.com/go-sql-driver/mysql"
)

var db *sql.DB
var dbConfig config.Database
var dbPath string

func Init() {
	var err error
	dbConfig = config.GetConfig().Database
	dbPath = fmt.Sprintf("%s:%s@(%s:%s)/%s?parseTime=true", dbConfig.User, dbConfig.Password, dbConfig.Host, dbConfig.Port, dbConfig.Database)

	db, err = sql.Open("mysql", dbPath)
	if err != nil {
		log.Println("Cannot connect to database !")
		log.Fatal(err)
	}

	err = db.Ping()
	if err != nil {
		log.Println("Cannot ping the database !")
		log.Fatal(err)
	}

	var query string = `SHOW GRANTS;`
	var rows *sql.Rows = executeQuery(query)
	defer rows.Close()

	for rows.Next() {
		var res string
		rows.Scan(&res)
		fmt.Println(res)
	}
}

func executeQuery(query string) *sql.Rows {
	var err error
	var rows *sql.Rows

	rows, err = db.Query(query)
	if err != nil {
		log.Println("Error while query DB :")
		log.Fatal(err)
	}

	return rows
}
